package com.tmax.openframe;

import ch.obermuhlner.math.big.BigDecimalMath;
import com.tmax.openframe.file.*;
import com.tmax.openframe.variable.COBTEST5_VariableContainer;
import com.tmax.openframe.variable.group.*;
import java.lang.Runnable;
import java.math.*;
import java.util.*;
import lombok.*;
import org.apache.commons.lang3.StringUtils;

/** 
 * <p>This source code was generated by COBOL to JAVA migrator</p>
 * <dl>
 * </dl>
 * <p>This describes files what declared in I/O sections: </p>
 * <ul>
 * <li>
 * IN-F: file class {@code ->} {@link COBTEST5_FD_IN_F}, record class {@code -> } {@link COBTEST5_EMDAIYC}
 * <p>organization type: FILE_ORG_INDEXED</p>
 * <p>key: DL-KEY</p>
 * </li>
 * <li>
 * OUT-F: file class {@code ->} {@link COBTEST5_FD_OUT_F}, record class {@code -> } {@link COBTEST5_EMTXDAC}
 * <p>organization type: FILE_ORG_SEQUENTIAL</p>
 * <p>key: no key</p>
 * </li>
 * </ul>
 */
public class COBTEST5 implements Runnable {
    private @Getter Integer returnValue = 0;
    private @Getter COBTEST5_VariableContainer container = new COBTEST5_VariableContainer();
    COBTEST5_FD_IN_F FD_IN_F;
    COBTEST5_FD_OUT_F FD_OUT_F;
    Runnable MAIN_RTN = this::MAIN_RTN;
    Runnable IN_READ = this::IN_READ;
    Runnable IN_READ_EX = this::IN_READ_EX;
    Runnable WRITE_RTN = this::WRITE_RTN;
    Runnable WRITE_RTN_EX = this::WRITE_RTN_EX;
    Runnable OUT_WRITE = this::OUT_WRITE;
    Runnable OUT_WRITE_EX = this::OUT_WRITE_EX;
    Runnable OUT_REPL = this::OUT_REPL;
    Runnable OUT_REPL_EX = this::OUT_REPL_EX;
    Runnable GoTo;
    boolean Return;
    ArrayList<Runnable> MethodFlow = new ArrayList<>();
    {
        MethodFlow.add(MAIN_RTN);
        MethodFlow.add(IN_READ);
        MethodFlow.add(IN_READ_EX);
        MethodFlow.add(WRITE_RTN);
        MethodFlow.add(WRITE_RTN_EX);
        MethodFlow.add(OUT_WRITE);
        MethodFlow.add(OUT_WRITE_EX);
        MethodFlow.add(OUT_REPL);
        MethodFlow.add(OUT_REPL_EX);
    }

    public COBTEST5() {
        FD_IN_F = new COBTEST5_FD_IN_F();
        FD_OUT_F = new COBTEST5_FD_OUT_F();
    }

    public @Override void run() {
        run(MAIN_RTN, OUT_REPL_EX);
    }

    private void run(Runnable start) {
        run(start, null);
    }

    private void run(Runnable start, Runnable end) {
        List<Runnable> runList;
        if (end == null) {
            runList = Collections.singletonList(start);
        } else {
            runList = MethodFlow.subList(MethodFlow.indexOf(start),
                    MethodFlow.indexOf(end) + 1);
        }
        int i = 0;
        while (i < runList.size()) {
            runList.get(i).run();
            if (GoTo != null) {
                for (Runnable runUnit : runList) {
                    if (GoTo == runUnit) {
                        i = runList.indexOf(runUnit);
                        GoTo = null;
                        break;
                    }
                }
                if (GoTo != null) {
                    return;
                }
            } else {
                i++;
            }
            if (Return) {
                return;
            }
        }
    }

    void MAIN_RTN() {
        container.setIN_CNT(0);
        container.setSKIP_CNT(0);
        container.setWRITE_CNT(0);
        container.setREWRITE_CNT(0);
        run(IN_READ, IN_READ_EX);
        if (GoTo != null || Return) {
            return;
        }
        while (!(StringUtils.stripEnd(
                container.getEMDAIYC().getDL_KEY().toString(), " ").compareTo(
                StringUtils.repeat((char) 0xFF, 20)) == 0)) {
            run(WRITE_RTN, WRITE_RTN_EX);
            if (GoTo != null || Return) {
                return;
            }
        }
        System.out.println(" ");
        FD_IN_F.close();
        FD_OUT_F.close();
        System.out.println("*==== RUN RESULT  (DEMPTD02) ====*");
        System.out.print(" EMDAIYF-READ-CNT    = ");
        System.out.println(container.getIN_CNT());
        System.out.print(" EMDAIYF-SKIP-CNT    = ");
        System.out.println(container.getSKIP_CNT());
        System.out.print(" EMTXDAF-WRITE-CNT   = ");
        System.out.println(container.getWRITE_CNT());
        System.out.print(" EMTXDAF-REWRITE-CNT = ");
        System.out.println(container.getREWRITE_CNT());
        System.out.println("*================================*");
        Return = true;
        return;
    }

    void IN_READ() {
        COBTEST5_EMDAIYC temp_COBTEST5_EMDAIYC1;
        container.getEMDAIYC().getDL_KEY().set("700725247772423782");
        temp_COBTEST5_EMDAIYC1 = FD_IN_F.readNext();
        if (temp_COBTEST5_EMDAIYC1 != null) {
            container.setEMDAIYC(temp_COBTEST5_EMDAIYC1);
        }
        container.setIN_CNT(container.getIN_CNT() + 1);
    }

    void IN_READ_EX() {
    }

    void WRITE_RTN() {
        run(OUT_WRITE, OUT_WRITE_EX);
        if (GoTo != null || Return) {
            return;
        }
    }

    void WRITE_RTN_EX() {
    }

    void OUT_WRITE() {
        container.setEMTXDAC(COBTEST5_EMTXDAC.createDefaultValueInstance());
        System.out.println("*==11111==============================*");
        container.getEMTXDAC().getTX_KEY()
                .set(container.getEMDAIYC().getDL_KEY());
        container.getEMTXDAC().setTX_LCYM(container.getEMDAIYC().getDL_LCYM());
        container.getEMTXDAC().setTX_LPMT(container.getEMDAIYC().getDL_LPMT());
        System.out.println("*==222222222==========================*");
        FD_OUT_F.write(container.getEMTXDAC());
        container.setWRITE_CNT(container.getWRITE_CNT() + 1);
        container.getEMDAIYC().setDL_KEY(
                COBTEST5_DL_KEY.createDefaultValueInstance());
    }

    void OUT_WRITE_EX() {
    }

    void OUT_REPL() {
        container.setREWRITE_CNT(container.getREWRITE_CNT() + 1);
        System.out.print(" EMTXDAF-DUP-RECORD  = ");
        System.out.println(container.getEMTXDAC().getTX_KEY());
    }

    void OUT_REPL_EX() {
    }
}
